
#ifndef _FILE_WRITE_H_
#define _FILE_WRITE_H_

//#include <windows.h>
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include "tcp_recv.h"

#pragma warning(disable:4819)
#include "opencv2/opencv.hpp"
#pragma warning(default:4819)

DWORD WINAPI FileWriteWorker(LPVOID arg);
void SearchHeader(
	unsigned char *ptr,
	struct HEADER_INFO *header_info
);

struct HEADER_INFO {
	int state; // header search state
	int found;
	unsigned long tot_len;
	unsigned long type1;
	unsigned long type2;
	unsigned long aux0;
	unsigned long aux1;
	unsigned long aux2;
	unsigned long aux3;
	int tot_height;
	int tot_width;
	int act_height;
	int act_width;
	int bytes_per_chunk; // ff[^̋؂oCgB̃oCgPʂŉff[^͂B
	int pixels_per_chunk; // P؂Ɋ܂܂fBLR摜̏ꍇL̕ƂR̕킹B
	int encode; // encode type
};

void GetLum(cv::Mat *matImgActive, int row, int col, unsigned char *pix_buf);
void GetLumLR(cv::Mat *matImgActive, int row, int col, unsigned char *pix_buf, int W);
void GetDispInteger(cv::Mat *matImgActive, int row, int col, unsigned char *pix_buf);
void GetPixelBgr(cv::Mat *matImgActive, int row, int col, unsigned char *ch, int W);
void YUVtoBGR(unsigned char y, unsigned char u, unsigned char v, cv::Vec3b *bgr);

#endif // _FILE_WRITE_H_
